pub mod cpp_s;
pub mod ts_c;

#[derive(Debug, Clone, clap::ValueEnum)]
pub enum ServerGenerators {
    Cpp
}

#[derive(Debug, Clone, clap::ValueEnum)]
pub enum ClientGenerators {
    Ts
}

impl ServerGenerators {
    pub fn generate(&self, file_base_name: &std::path::PathBuf, rpc: &crate::data::RPC) {
        match self {
            Self::Cpp => cpp_s::gen(file_base_name, rpc)
        }
    }
}

impl ClientGenerators {
    pub fn generate(&self, file_base_name: &std::path::PathBuf, rpc: &crate::data::RPC) {
        match self {
            Self::Ts => ts_c::gen(file_base_name, rpc)
        }
    }
}
